#!/usr/bin/perl
# edit_command.cgi
# Displays a form to construct commands that can be used
# in the rules defined in the /etc/hosts.allow and /etc/hosts.deny files

require './tcpw-lib.pl';
&ReadParse();

if ($in{'submit'} eq $text{'index_accept'}) {
	$var = "edit_rule.cgi?file=$in{'file'}&addcomm=1";
	if ($in{'line'}) { $var= $var . "&line=$in{'line'}"; }
	if ($in{'size'}) { $var= $var . "&size=$in{'size'}"; }
	&redirect($var);
}

&header($text{'index_command_head'}, "", "addcomm");


# Deletes a command added to a rule
if ($in{'submit'} eq $text{'index_delete'}) {
	open (ARCHIVO, "commands.tmp");
	@rule_commands = <ARCHIVO>;
	close (ARCHIVO);
	splice (@rule_commands, $in{'pos'}, 1);
	open (ARCHIVO, "> commands.tmp");
	print ARCHIVO @rule_commands;
	close (ARCHIVO);
	$delete = 1;
}	

if ($in{'continue'} != 1) { open (TEMPCOMM, "> commands.tmp"); }
else { open (TEMPCOMM, ">> commands.tmp"); }


# Add command to the array rule_commands
if ($in{'submit'} eq $text{'index_add_command'}) {
	$rule_commands = $in{'array'};
	$goodcomm = 0;
	$command = "";
	if ($in{'comm'} == 1) {
		$command = "banners ";
		if ($in{'file'} eq $config{'hosts_allow_file'}) {
			$command = $command . "$config{'banners_allow_dir'}";
			$path = $config{'banners_allow_dir'};
			}
		if ($in{'file'} eq $config{'hosts_deny_file'}) {
			$command = $command . "$config{'banners_deny_dir'}";
			$path = $config{'banners_deny_dir'};
			}
		if ($in{'message'}) {
			$goodcomm = 1;
			open (BANNER, "> banner.tmp");
			print BANNER $in{'message'};
			close (BANNER);
			@temp_array = &get_rule("rule.tmp",1,1);
			&fill_banners_dir($path,$temp_array[0],$in{'message'});
			}
	}
	if ($in{'comm'} == 2) {
		$command = "$in{'comm2'} ";
		if ($in{'comm2'} eq "spawn") {
			if ($in{'commpath'}) {
				if ($in{'mail'}) { $command = $command . "("; }
				if ($in{'args'}) {
					$var = "$in{'commpath'} " . "$in{'args'}";
					$command = $command . "$var";
				}
				else { $command = $command . "$in{'commpath'} "; }
				if ($in{'mail'}) {
					$command = $command . " | " . "/bin/mail ";
					if ($in{'subject'}) {
						$command = $command . "-s \"$in{'subject'}\"";
					}
					$command = $command . " root ";
					$command = $command . ")";
				}
			$goodcomm = 1;
			}
		}
		else {
			if ($in{'commpath'}) {
				$command = $command . "$in{'commpath'}";
				$goodcomm = 1;
				if ($in{'args'}) { $command = $command . " $in{'args'}"; }
			}
		}		
	}
	if ($in{'comm'} == 3) {
		$command = "$in{'comm3'}";
		if ($in{'value3'}) { $command = $command . " $in{'value3'}"; }
		$goodcomm = 1;		
	}
	if ($goodcomm == 1) {
		$command = $command . "\n";
		print TEMPCOMM $command;
	}	
}
	
close(TEMPCOMM);

# Form to build your commands to be used in your rules
print "<form action=edit_command.cgi>\n";
print "<table border>\n";
print "<tr $tb><td colspan=3><b>$text{'index_command'}</b></td></tr>\n";

print "<tr $cb><td><table width=100%><tr>\n";
print "<td><input type=radio name=comm value=1></td>\n";
print "<td> banners: </td>\n";
print "<td><textarea rows=4 cols=35 name=message></textarea></td>\n";
print "</tr></table><hr>\n";

print "<table width=100%><tr>\n";
print "<td><input type=radio name=comm value=2></td>\n";
print "<td><select name=comm2>\n";
print "<option value=\"\">Select Command\n";
$i = 0;
@arr = &sub_array(@commands,12);
splice(@arr,0,10);
$tamano = @arr;
while ($i < $tamano) {
	print "<option value=$arr[$i]>$arr[$i]\n";
	$i++;
	}
print "</select></td><td>\n";
printf "<input name=commpath size=20 value=\"%s\">\n";
print &file_chooser_button("commpath", 0);
print "</td></tr>\n";
print "<tr><td></td>\n";
print "<td align=right>$text{'index_args'}: </td>\n";
print "<td><input type=text name=args size=20></td>\n";
print "<tr><td></td>\n";
print "<td><input type=checkbox name=mail>  $text{'index_send_mail'}</td></tr>\n";
print "<tr><td></td>\n";
print "<td align=right>$text{'index_subject'}: </td>\n";
print "<td><input type=text name=subject size=20></td>\n";
print "</tr></table><hr>\n";

print "<table width=100%><tr>\n";
print "<td><input type=radio name=comm value=3></td>\n";
print "<td><select name=comm3>\n";
print "<option value=\"\">Select Command\n";
$i = 0;
@arr = &sub_array(@commands,10);
$tamano = @arr;
while ($i < $tamano) {
	print "<option value=$arr[$i]>$arr[$i]\n";
	$i++;
	}
print "</select></td>\n";
print "<td align=left><input type=text name=value3 size=20></td>\n";
print "</tr></table>\n";

print "</td></tr></table>\n";

print "<input type=hidden name=continue value=1>\n";
print "<input type=hidden name=file value=\"$in{'file'}\">\n";
if ($in{'line'}) { print "<input type=hidden name=line value=\"$in{'line'}\">\n"; }
if ($in{'size'}) { print "<input type=hidden name=size value=\"$in{'size'}\">\n"; }
print "<input type=submit name=submit value=$text{'index_add_command'}>\n";

print "<hr>";

if ($delete == 1) {
	print "<b>$text{'index_message_delete_command'}!</b><br>\n";
}
# Form that shows the command that has been already added
open(ARCHIVO, "commands.tmp");
@rule_commands = <ARCHIVO>;
close(ARCHIVO);
$length = @rule_commands;
if ($length != 0) {
	print "<table width=100% border=1>\n";
	print "<tr $tb>\n";
	print "<td align=center><font color=#9999ff>xx</font></td>\n";
	print "<td align=center><b> $text{'index_command'} </b></td>\n";
	print "<td align=center><b> $text{'index_args2'} </b></td>\n";
	print "</tr>\n";
	
	$i = 0;
	while ($i < $length)
	{
		print "<tr $cb>\n";
		if ($rule_commands[$i] =~ /(\S+)\s*(.*)/) {
			print "<td align=center> <input type=radio name=pos value=$i> </td>\n";
			print "<td align=center> $1 </td>\n";
			if ($2) { print "<td align=center> $2 </td>\n"; }
			else { print "<td align=center> $text{'index_none'} </td>\n"; }
		}
		print "</tr>\n";
		$i++;
	}

	print "</table>\n";
	print "<input type=submit name=submit value=$text{'index_delete'}>\n";
	print "<input type=submit name=submit value=$text{'index_accept'}>\n";
}
print "</form>\n";

$var = "edit_rule.cgi?file=$in{'file'}&init=1";
if ($in{'line'}) {
	$var= $var . "&line=$in{'line'}";
	$edit = 1;
}
if ($in{'size'}) { $var= $var . "&size=$in{'size'}"; }

if ($edit == 1) { &footer($var, $text{'index_return3'}); }
else { &footer($var, $text{'index_return2'}); }