#!/usr/bin/perl
# edit_rule.cgi
# Displays a form to construct rules for the acces files
# handled by the TCP Wrappers daemon

require './tcpw-lib.pl';
&ReadParse();


if ($in{'line'}) {
	&header($text{'index_rule2'}, "", "editrule");
	}
else {
	&header($text{'index_rule1'}, "", "addrule");
	}

#init temporary files
if ($in{'init'} == 1) { &init_temporary_files; }


#gets the rule from the temporary file rule.tmp and command.tmp
if ($in{'addcomm'} == 1) {
	@hlist = &get_rule("rule.tmp",1,1);
	open (ARCHIVO, "commands.tmp");
	@rule_commands = <ARCHIVO>;
	close (ARCHIVO);
	push (@hlist,(@rule_commands));
	@arreglo = &service_interpreter($hlist[0]);
	@arreglo2 = &host_interpreter($hlist[1]);
	@rule = @hlist;
	$tamano_rule = @rule;
	$haycomm = $in{'addcomm'};
	if (($in{'line'}) and ($in{'size'})) { $edit = 1; }
}

#gets the rule from the original file /etc/hosts.allow or /etc/hosts.deny	
if (($in{'line'}) and ($in{'size'}) and ($in{'addcomm'} != 1)) {
	$edit = 1;
	@hlist = &get_rule($in{'file'},$in{'line'},$in{'size'});
	@arreglo = &service_interpreter($hlist[0]);
	@arreglo2 = &host_interpreter($hlist[1]);
	@rule = @hlist;
	$tamano_rule = @rule;
}
print "<hr>\n";


#DAEMON
print "<form action=";
if ($edit == 1) { print "modify_rule.cgi"; }
else { print "save_rule.cgi"; }
print "><table border>\n";
print "<tr $tb><td colspan=3><b>$text{'index_daemon'}</b></td></tr>\n";
print "<tr $cb><td><table width=100%><tr><td>\n";
print "<input type=radio ";
if ($arreglo[1] eq  $text{'wildcard_all'}) {
	print "checked ";
	}
print "name=serv value=$text{'wildcard_all'} %s></td> <td> $text{'index_tag_all'}   $text{'index_tag_except'}: </td>\n";
print "<td> <select name=serv2>\n";
if ($arreglo[0]==3) {
	print "<option value=\"$arreglo[3]\">$arreglo[3]\n";
	}
else {
	print "<option value=\"\">$text{'index_selserv'}\n";
	}
$i = 0;
@hlist = &list_inets();
foreach $h (@hlist) {
	if ($h->[6] eq $config{'tcpd_path'}) {
		print "<option value=";
		if ($h->[7]) {
			$value = &get_daemon($h->[7]);
			print "$value";
			}
		else { print "$h->[1]"; }
		print ">$h->[1]($h->[3])\n";
		}
	$i++;
	}
print "</select>\n";
print "</td></tr>\n";
print "<tr $cb><td>\n";
print "<input type=radio ";
if ((@arreglo) and ($arreglo[1] ne  $text{'wildcard_all'})) {
	print "checked ";
	}
print "name=serv value=1 %s></td> <td> $text{'index_tag_service'}: </td>\n";
print "<td> <select name=serv3> \n";
if ((@arreglo) and ($arreglo[1] ne  $text{'wildcard_all'})) {
	print "<option value=\"$arreglo[1]\">$arreglo[1]\n";
	}
else {	
	print "<option value=\"\">$text{'index_selserv'}\n";
	}
$i = 0;
@hlist = &list_inets();
foreach $h (@hlist) {
	if ($h->[6] eq $config{'tcpd_path'}) {
		print "<option value=";
		if ($h->[7]) {
			$value = &get_daemon($h->[7]);
			print "$value";
			}
		else { print "$h->[1]"; }
		print ">$h->[1]($h->[3])\n";
		}
	$i++;
	}
print "</select>\n";
print "</td></tr></table>\n";
print "</tr></td></table>\n";


#CLIENT
print "<table border>\n";
print "<tr $tb><td><b>$text{'index_client'}</b></td></tr>\n";
print "<tr $cb><td><table>\n";

# opcion 4 WILDCARD
print "<tr><td>\n";
print "<input type=radio ";
if (($arreglo2[0] == 4) and ($arreglo2[1] ne $text{'wildcard_all'})) { print "checked "; }
print "name=client value=4 %s></td>\n";
print "<td> <select name=client4> \n";
print "<option value=";
if (($arreglo2[0] == 4) and ($arreglo2[1] ne $text{'wildcard_all'})) { print "$arreglo2[1]>$arreglo2[1]\n"; }
else { print "\"\">Select Wildcard\n"; }
$i = 0;
@arr = &sub_array(@wildcards,4);
$tamano = @arr;
while ($i < $tamano) {
	print "<option value=$arr[$i]>$arr[$i]\n";
	$i++;
	}
print "</select>\n";
print "</td></tr>\n";

# opcion 3 ALL WITH/WITHOUT EXCEPT
print "<tr><td>\n";
print "<input type=radio ";
if (($arreglo2[0] == 3) or (($arreglo2[0] == 4) and ($arreglo2[1] eq $text{'wildcard_all'}))) { print "checked "; }
print "name=client value=$text{'wildcard_all'} %s></td> <td>$text{'index_tag_all'} $text{'index_tag_except'}:\n";
print " <input type=text name=client3 ";
if ($arreglo2[0] == 3) { print "value=$arreglo2[3] "; }
print "> </td></tr>\n";

#  opcion 5 WILDCARD @ WILDCARD
print "<tr><td>\n";
print "<input type=radio ";
if ($arreglo2[0] == 5) { print "checked "; }
print "name=client value=5 %s></td>\n";
print "<td> <select name=client5> \n";
print "<option value=";
if ($arreglo2[0] == 5) { print "$arreglo2[1]>$arreglo2[1]\n"; }
else { print "\"\">Select Wildcard\n"; }
$i = 0;
@arr = &sub_array(@wildcards,2);
$tamano = @arr;
while ($i < $tamano) {
	print "<option value=$arr[$i]>$arr[$i]\n";
	$i++;
	}
print "</select>\n";
print " @\n";
print "<td> <select name=client6> \n";
print "<option value=";
if ($arreglo2[0] == 5) { print "$arreglo2[2]>$arreglo2[2]\n"; }
else { print "\"\">Select Wildcard\n"; }
$i = 0;
@arr = &sub_array(@wildcards,3);
$tamano = @arr;
while ($i < $tamano) {
	print "<option value=$arr[$i]>$arr[$i]\n";
	$i++;
	}
print "</select>\n";
print "</td></tr>\n";

# opcion 2 HOSTS AND MASK
print "<tr><td>\n";
print "<input type=radio ";
if ($arreglo2[0] == 2) {	print "checked "; }
print "name=client value=2 %s></td> <td>$text{'index_tag_host'}: <input type=text name=client2 ";
if ($arreglo2[0] == 2) {	print "value=\"$arreglo2[1]\" "; }
print " >\n";
print "  $text{'index_tag_mask'}: <input type=text name=mask ";
if ($arreglo2[0] == 2) { print "value=$arreglo2[2] "; }
print "size=20> </td></tr>\n";

# opcion 1 CLIENT
print "<tr><td>\n";
print "<input type=radio ";
if ($arreglo2[0] == 1) { print "checked "; }
print "name=client value=1 %s></td>\n";
print "<td> $text{'index_tag_client'}: <input type=text name=client1 ";
if ($arreglo2[0] == 1) { print "value=\"$arreglo2[1]\" "; }
print "size=40></td></tr>\n";
print "</table></td></tr></table>\n";

#COMMAND
if ($tamano_rule > 2) {
	$haycomm = 1;
	@rule_commands = splice (@rule,2,$tamano_rule);
	$tamano = @rule_commands;
	if ($in{'addcomm'} != 1) {
		open (ARCHIVO, "> commands.tmp");
		$i = 0;
		while ($i < $tamano) {
			print ARCHIVO $rule_commands[$i];
			if ($rule_commands[$i] =~ /\n$/) { }
			else { print ARCHIVO "\n"; }
			$i++;
		}
		close (ARCHIVO);
	}
}


#if the rules has commands defined...
if ($haycomm == 1) {
	print "<table border=1>\n";
	print "<tr $tb><td><b>$text{'index_command'}</b></td></tr>\n";
	print "<tr $cb><td><table width=100%>\n";
	$i = 0;
	while ($i < $tamano) {
		print "<tr>\n";
		if ($rule_commands[$i] =~ /(\S+)\s*(.*)/) {
			print "<td align=center><b> $1 </b></td>\n";
			print "<td align=center> $2 </td>\n";
		}
		print "</tr>\n";
		$i++;
	}
        print "</table></td></tr></table>\n";
}


print "<input type=hidden name=file value=\"$in{'file'}\">\n";
print "<input type=hidden name=continue value=\"$haycomm\">\n";

if ($edit == 1) {
	print "<input type=hidden name=line value=\"$in{'line'}\">\n";
	print "<input type=hidden name=size value=\"$in{'size'}\">\n";
	}
print "<input type=submit name=submit value=\"$text{'index_command'}\">\n";	
print "<input type=submit name=submit value=";
if ($edit == 1) { print "\"$text{'index_modify'}\""; }
else { print "\"$text{'index_save'}\""; }
print "></form>\n";


print "<hr>\n";

#display action messages
if ($in{'new'} == 1) {
	print "<b>$text{'index_message_new_rule'} <tt>$in{'file'}</tt> $text{'index_file'}!</b><br>\n";
	}
if ($in{'del'} == 1) {
	print "<b>$text{'index_message_delete_rule'} <tt>$in{'file'}</tt> $text{'index_file'}!</b><br>\n";
	}
if ($in{'mod'} == 1) {
	print "<b>$text{'index_message_modify_rule'} <tt>$in{'file'}</tt> $text{'index_file'}!</b><br>\n";
	}

#break down into hosts allowed/denied by the tcp wrappers
@hlist = &list_rules($in{'file'});
print "<form action=delete_rule.cgi><table border width=100%>\n";
print "<tr $tb> <td><b>";
if ($in{'file'} eq $config{'hosts_allow_file'}) { print "$text{'index_tcpw_allow'}"; }
if ($in{'file'} eq $config{'hosts_deny_file'}) { print "$text{'index_tcpw_deny'}"; }
print "</b></td> </tr>\n";
if ($hlist[0] == 0) { print "<tr $cb><td><b>$text{'index_no_rules'}</b></td></tr></table><br>\n"; }
else {
	print "<tr> <td><table width=100%>\n";
	print "<tr $tb> <td><font color=9999ff>xx</font></td>\n";
	print "         <td align=center><b>$text{'index_service'}</b></td>\n
			<td align=center><b>$text{'index_allow'}</b></td>\n
			<td align=center><b>$text{'index_command'}</b></td>\n
       		</tr>\n";

	$i = 0;

	foreach $h (@hlist) {
		print "<tr $cb>\n";
		print "<td align=center> <input type=radio name=line value=$h->[0]></td>\n";
		print "	        <td align=center>$h->[2]</td>\n";
		print "		<td align=center>$h->[3]</td>\n";
		$tamano = scalar(@$h);
		print "<td align=center>\n";
		$haycomm = 0;
		$i2 = 4;
		while ($i2 < $tamano) {
			$h->[$i2] =~ /\s*(\S+)\s*(.*)/;
			print "<b>$1</b>";
			print "<br>\n";
			$haycomm = 1;
			$i2++;
		}
		if ($haycomm == 0) { print "$text{'index_none'}"; }
		#print "</td>";
		#print "<td align=center>\n";
		#if ($i == 3) {
		#	print "<a href=\"move_http.cgi?$i+1\">",
		#	      "<img src=images/down.gif border=0></a>";
		#	}
		#else { print "<img src=images/gap.gif>"; }
		#if ($i != 0) {
		#	print "<a href=\"move_http.cgi?$i+-1\">",
		#	      "<img src=images/up.gif border=0></a>";
		#	}
		print "</td></tr>\n";
		$i++;
		}
	print "</table></td></tr></table>\n";
	print "<input type=hidden name=file value=\"$in{'file'}\">\n";
	print "<input type=submit name=submit value=\"$text{'index_delete'}\">\n";
	print "</form>\n";
}

print "<hr>\n";


&footer("", $text{'index_return'});