#!/usr/bin/perl
# index.cgi
# Display a list of services handled by the inetd daemon
# Display all the rules specified and to be used by the TCP Wrappers daemon.

require './tcpw-lib.pl';
&header($text{'index_title'}, "", "intro", 1, 1, "", "<a href=\"view_log.cgi\">$text{'index_view_log'}</a>");
print "<hr>\n";

# break down into internet services
print "<form action=modify_inet.cgi><table border width=100%>\n";
print "<tr $tb> <td><b>$text{'index_service_protected'}</b></td> </tr>\n";
print "<tr $cb> <td><table width=100%>\n";

$i = 0;
@service = ();
@slist = &list_inets();
foreach $s (@slist) {
	if ($i%4 == 0) { print "<tr>\n"; }
	print "<td>\n";
	if ($s->[6] eq $config{'tcpd_path'}) { print "<b>"; }
	print "<a href=\"show_service.cgi?line=$s->[0]\">$s->[1]</a>";
	if ($s->[6] eq $config{'tcpd_path'}) { print "</b>"; }
	print "($s->[3])";
	print "</td>\n";
	if ($i++%4 == 3) { print "</tr>\n"; }
	}
print "</table></td></tr></table>\n";
print "<br>\n";

print "<hr>\n";


#break down into hosts allowed by the tcp wrappers
@hlist = &list_rules($config{'hosts_allow_file'});
print "<form><table border width=100%>\n";
print "<tr $tb> <td><b>$text{'index_tcpw_allow'}</b></td> </tr>\n";
if ($hlist[0] == 0) { print "<tr $cb><td><b>$text{'index_no_rules'}</b></td></tr></table><br>\n"; }
else {
	print "<tr> <td><table width=100%>\n";
	print "<tr $tb> <td align=center><b>$text{'index_service'}</b></td>\n
			<td align=center><b>$text{'index_allow'}</b></td>\n
			<td align=center><b>$text{'index_command'}</b></td>\n
       		</tr>\n";
	$i = 0;
	foreach $h (@hlist) {
		print "<tr $cb> <td align=center><a href=edit_rule.cgi?file=$config{'hosts_allow_file'}&line=$h->[0]&size=$h->[1]&init=1>";
		print "$h->[2]</a></td>\n";
		$tamano = scalar(@$h);
		print "		<td align=center>$h->[3]</td>\n";
		print "<td align=center>";
		$haycomm = 0;
		$i2 = 4;
		while ($i2 < $tamano) {
			$h->[$i2] =~ /\s*(\S+)\s*(.*)/;
			print "<b>$1</b>";
			print "<br>\n";
			$haycomm = 1;
			$i2++;
		}
		if ($haycomm == 0) { print "$text{'index_none'}"; }
		print "</td></tr>\n";
		$i++;
		}
	print "</table></td></tr></table></form>\n";
}
print "<a href=edit_rule.cgi?file=$config{'hosts_allow_file'}&init=1>$text{'index_add'}</a> <p>\n";

print "<hr>\n";


#break down into hosts denied by the tcp wrappers
@hlist = &list_rules($config{'hosts_deny_file'});
print "<form><table border width=100%>\n";
print "<tr $tb> <td><b>$text{'index_tcpw_deny'}</b></td> </tr>\n";
if ($hlist[0] == 0) { print "<tr $cb><td><b>$text{'index_no_rules'}</b></td></tr></table><br>\n"; }
else {
	print "<tr> <td><table width=100%>\n";
	print "<tr $tb> <td align=center><b>$text{'index_service'}</b></td>\n
			<td align=center><b>$text{'index_deny'}</b></td>\n
			<td align=center><b>$text{'index_command'}</b></td>\n
       		</tr>\n";
	$i = 0;

	foreach $h (@hlist) {
		print "<tr $cb> <td align=center><a href=edit_rule.cgi?file=$config{'hosts_deny_file'}&line=$h->[0]&size=$h->[1]&init=1>";
		print "$h->[2]</a></td>\n";
		$tamano = scalar(@$h);
		print "		<td align=center>$h->[3]</td>\n";
		print "<td align=center>";
		$haycomm = 0;
		$i2 = 4;
		while ($i2 < $tamano) {
			$h->[$i2] =~ /\s*(\S+)\s*(.*)/;
			print "<b>$1</b>";
			print "<br>\n";
			$haycomm = 1;
			$i2++;
		}
		if ($haycomm == 0) { print "$text{'index_none'}"; }
		print "</td></tr>";
		$i++;
		}
	print "</table></td></tr></table></form>\n";
}
print "<a href=edit_rule.cgi?file=$config{'hosts_deny_file'}&init=1>$text{'index_add'}</a> <p>\n";

print "<hr>\n";

&footer("/", $text{'index'});

