#!/usr/bin/perl
# view_log.cgi
# Shows the tcpds log files

require './tcpw-lib.pl';

&header($text{'index_view_log_title'}, "", "viewlog");
&ReadParse();

print "<hr>\n";

print "<a name=inicio>\n";
print "<a href=#service>$text{'index_log_title_by_service'}</a><br>\n";
#print "<a href=#host>$text{'index_log_title_by_host'}</a><br>\n";
print "<a href=#input>$text{'index_log_title_view_input'}</a><br>\n";

@arreglo = `grep connect $config{'tcpd_log_file'}`;

print "<hr>\n";
print "<div align=left><a name=service></div>\n";
print "<h2>$text{'index_log_title_by_service'}</h2>\n";
print "<table border><tr $tb>\n";
print "<td align=center><b>$text{'index_service'}</b></td>\n";
print "<td align=center><b>$text{'index_total_connect'}</b></td>\n";
print "<td align=center><b>$text{'index_succesful'}</b></td>\n";
print "<td align=center><b>%</b></td>\n";
print "<td align=center><b>$text{'index_refused'}</b></td>\n";
print "<td align=center><b>%</b></td>\n";
print "</tr>\n";
@hlist = &list_inets();
$count_total = 0;
$count_suc = 0;
$count_ref = 0;
foreach $h (@hlist) {
	if ($h->[6] eq $config{'tcpd_path'}) {
		if ($h->[7]) { $value = &get_daemon($h->[7]); }
		else { $value = $h->[1]; }
		print "<tr $cb>\n";
		print "<td align=center><b>$h->[1]</b></td>\n";
		@arreglo = `grep $value $config{'tcpd_log_file'}`;
		$totalco = @arreglo;
		$count_total = $count_total + $totalco;
		print "<td align=center>$totalco</td>\n";
		$totalsuc = &log_counter(@arreglo,"connect");
		$count_suc = $count_suc + $totalsuc;
		print "<td align=center>$totalsuc</td>\n";
		if ($totalco != 0) { $porcentaje = ($totalsuc/$totalco)*100; }
		else { $porcentaje = 0; }
		print "<td align=center>"; printf "%.2f","$porcentaje"; print "</td>\n";
		$totalref = &log_counter(@arreglo,"refused");
		$count_ref = $count_ref + $totalref;
		print "<td align=center>$totalref</td>\n";
		if ($totalco != 0) { $porcentaje = ($totalref/$totalco)*100; }
		else { $porcentaje = 0; }
		print "<td align=center>"; printf "%.2f","$porcentaje"; print "</td>\n";
		print "<tr>\n";
	}
	$i++;
}
print "<tr $cb>\n";
print "<td align=center><b>$text{'index_total'}</b></td>\n";
print "<td align=center>$count_total</td>\n";
print "<td align=center>$count_suc</td>\n";
if ($count_total != 0) { $porcentaje = ($count_suc/$count_total)*100; }
else { $porcentaje = 0; }
print "<td align=center>"; printf "%.2f","$porcentaje"; print "</td>\n";
print "<td align=center>$count_ref</td>\n";
if ($count_total != 0) { $porcentaje = ($count_ref/$count_total)*100; }
else { $porcentaje = 0; }
print "<td align=center>"; printf "%.2f","$porcentaje"; print "</td>\n";
print "</tr></table>\n";

print "<hr>\n";
print "<div align=right><a href=#inicio>$text{'index_log_top'}</a></div>\n";

#print "<hr>\n";
#print "<div align=left><a name=host></div>\n";
#print "<h2>$text{'index_log_title_by_host'}</h2>\n";


#print "<hr>\n";
#print "<div align=right><a href=#inicio>$text{'index_log_top'}</a></div>\n";


#print "<hr>\n";
print "<div align=left><a name=input></div>\n";
print "<h2>$text{'index_log_title_view_input'}</h2>\n";
print "$text{'index_log_input_message'}\n";
print "<form action=view_log.cgi>\n";
print "<table><tr>\n";
print "<td>$text{'index_service'}:</td>\n";
print "<td><select name=service>\n";
print "<option value=\"\">$text{'index_selserv'}\n";
$i = 0;
@hlist = &list_inets();
foreach $h (@hlist) {
	if ($h->[6] eq $config{'tcpd_path'}) {
		print "<option value=";
		if ($h->[7]) {
			$value = &get_daemon($h->[7]);
			print "$value";
			}
		else { print "$h->[1]"; }
		print ">$h->[1]($h->[3])\n";
		}
	$i++;
	}
print "</select></td></tr>\n";
print "<tr><td>$text{'index_host'}:</td>\n";
print "<td><input type=text name=host size=30></td></tr>\n";
print "<tr><td><input type=submit name=submit value=$text{'index_log_view_button'}></td><td></td></tr>\n";
print "</table></form>\n";

if (($in{'submit'}) and (($in{'service'}) or ($in{'host'}))) {
	if ($in{'service'}) {
		$registro = `grep $in{'service'} $config{'inetd_conf_file'}`;
		if ($registro =~ /\s*(\S+)\s*.+/) { $service_name = $1; }
	}	
	if (($in{'service'}) and (!$in{'host'})) {
		print "<b>$text{'index_log_results_service'}</b> <tt>$service_name</tt>.<br>\n";
	        @arreglo = `grep $in{'service'} $config{'tcpd_log_file'}`;
	}
	if ((!$in{'service'}) and ($in{'host'})) {
		print "<b>$text{'index_log_results_host'}</b> <tt>$in{'host'}</tt>.<br>\n";
                @arreglo = `grep $in{'host'} $config{'tcpd_log_file'}`;
	}
	if (($in{'service'}) and ($in{'host'})) {
		print "<b>$text{'index_log_results_service'}</b> <tt>$service_name</tt> <b>$text{'index_log_with'} $text{'index_host2'}</b> <tt>$in{'host'}</tt>.<br>\n";
                @arreglo = `grep $in{'service'} $config{'tcpd_log_file'}`;
		@arreglo = &log_sub_array(@arreglo,$in{'host'});
	}
	
	@arreglo = &log_sub_array(@arreglo,"connect");
	print "<table border>\n";
	print "<tr $tb>\n";
	print "<td align=center><b>$text{'index_log_date'}</b></td>\n";
	print "<td align=center><b>$text{'index_log_time'}</b></td>\n";
	if (($in{'service'}) and (!$in{'host'})) { print "<td align=center><b>$text{'index_host'}</b></td>\n"; }
	if ((!$in{'service'}) and ($in{'host'})) { print "<td align=center><b>$text{'index_service'}</b></td>\n"; }
	print "<td align=center><b>$text{'index_log_status'}</b></td>\n";
	print "</tr>\n";

	$tamano = @arreglo;
	if ($tamano == 0) { print "<tr $cb><td><b>$text{'index_log_no_result'}.</b></td></tr>\n"; }
	else {
		$i = 0;
		while ($i < $tamano) {
			@temp_array = ();
			print "<tr $cb>\n";
			if ($arreglo[$i] =~ /\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S+)\s*(\S*)/) {
				push (@temp_array, ($1, $2, $3, $4, $5, $6, $7, $8, $9));
				print "<td align=center>$temp_array[0], $temp_array[1]</td>\n";
				print "<td align=center>$temp_array[2]</td>\n";
				if (($in{'service'}) and (!$in{'host'})) {
					if ($temp_array[5] eq "refused") { $var = $temp_array[8]; }
					else { $var = $temp_array[7]; }
					if ($var =~ /\S+@(\S+)/) { print "<td align=center>$1</td>\n"; }
					else { print "<td align=center>$var</td>\n"; }
				}
				if ((!$in{'service'}) and ($in{'host'})) {
					if ($temp_array[4] =~ /(\S+)\[\S+\]/) {
						$registro = `grep $1 $config{'inetd_conf_file'}`;
						if ($registro =~ /\s*(\S+)\s*.+/) { print "<td align=center>$1</td>\n"; }	
						}
					else { print "<td align=center>$temp_array[4]</td>\n"; }
				}
				print "<td align=center>$temp_array[5]</td>\n";
			}
			print "</tr>";
			$i++;
		}
	}
	print "</table>\n";
}	

print "<hr>\n";
print "<div align=right><a href=#inicio>$text{'index_log_top'}</a></div>\n";
&footer("", $text{'index_return'});